# coding: utf-8

"""
    Zitadel SDK

    The Zitadel SDK is a convenience wrapper around the Zitadel APIs to assist you in integrating with your Zitadel environment. This SDK enables you to handle resources, settings, and configurations within the Zitadel platform.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List, Optional
from zitadel_client.models.action_service_beta_event_execution import ActionServiceBetaEventExecution
from zitadel_client.models.action_service_beta_function_execution import ActionServiceBetaFunctionExecution
from zitadel_client.models.action_service_beta_request_execution import ActionServiceBetaRequestExecution
from zitadel_client.models.action_service_beta_response_execution import ActionServiceBetaResponseExecution
from typing import Optional, Set
from typing_extensions import Self

class ActionServiceBetaCondition(BaseModel):
    """
    ActionServiceBetaCondition
    """ # noqa: E501
    request: Optional[ActionServiceBetaRequestExecution] = None
    response: Optional[ActionServiceBetaResponseExecution] = None
    function: Optional[ActionServiceBetaFunctionExecution] = None
    event: Optional[ActionServiceBetaEventExecution] = None

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ActionServiceBetaCondition from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ActionServiceBetaCondition from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "request": ActionServiceBetaRequestExecution.from_dict(obj["request"]) if obj.get("request") is not None else None,
            "response": ActionServiceBetaResponseExecution.from_dict(obj["response"]) if obj.get("response") is not None else None,
            "function": ActionServiceBetaFunctionExecution.from_dict(obj["function"]) if obj.get("function") is not None else None,
            "event": ActionServiceBetaEventExecution.from_dict(obj["event"]) if obj.get("event") is not None else None
        })
        return _obj


