# coding: utf-8

"""
    Zitadel SDK

    The Zitadel SDK is a convenience wrapper around the Zitadel APIs to assist you in integrating with your Zitadel environment. This SDK enables you to handle resources, settings, and configurations within the Zitadel platform.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zitadel_client.models.user_service_idpldap_access_information import UserServiceIDPLDAPAccessInformation
from zitadel_client.models.user_service_idpo_auth_access_information import UserServiceIDPOAuthAccessInformation
from zitadel_client.models.user_service_idpsaml_access_information import UserServiceIDPSAMLAccessInformation
from typing import Optional, Set
from typing_extensions import Self

class UserServiceIDPInformation(BaseModel):
    """
    UserServiceIDPInformation
    """ # noqa: E501
    oauth: Optional[UserServiceIDPOAuthAccessInformation] = None
    ldap: Optional[UserServiceIDPLDAPAccessInformation] = None
    saml: Optional[UserServiceIDPSAMLAccessInformation] = None
    idp_id: Optional[StrictStr] = Field(default=None, description="ID of the identity provider", alias="idpId")
    user_id: Optional[StrictStr] = Field(default=None, description="ID of the user of the identity provider", alias="userId")
    user_name: Optional[StrictStr] = Field(default=None, description="username of the user of the identity provider", alias="userName")
    raw_information: Optional[Dict[str, Any]] = Field(default=None, description="complete information returned by the identity provider", alias="rawInformation")

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UserServiceIDPInformation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UserServiceIDPInformation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "oauth": UserServiceIDPOAuthAccessInformation.from_dict(obj["oauth"]) if obj.get("oauth") is not None else None,
            "ldap": UserServiceIDPLDAPAccessInformation.from_dict(obj["ldap"]) if obj.get("ldap") is not None else None,
            "saml": UserServiceIDPSAMLAccessInformation.from_dict(obj["saml"]) if obj.get("saml") is not None else None,
            "idpId": obj.get("idpId"),
            "userId": obj.get("userId"),
            "userName": obj.get("userName"),
            "rawInformation": obj.get("rawInformation")
        })
        return _obj


